part of mvu_flutter;

/// Generic [Cmd] type
///
/// Value is not used anywhere, hence the dynamic type
typedef Cmd<ModelType extends Model, MsgType extends Msg> = dynamic
    Function(Dispatch<ModelType, MsgType> dispatch);

/// Initial [Program]'s [View] type
///
/// Must be a function for lazy initialization
typedef InitialView<ModelType extends Model, MsgType extends Msg>
    = View<ModelType, MsgType> Function();

/// [dispatch]/[dispatchGlobal] function type
typedef Dispatch<ModelType extends Model, MsgType extends Msg>
    = Future<void> Function(MsgType message);

/// [Subscriptions] function type
///
/// Subscriptions' type is dynamic because value is not used – subscriptions
/// are stored only for cancellation purposes
typedef Subscriptions<ModelType extends Model, MsgType extends Msg>
    = List<StreamSubscription> Function(Dispatch<ModelType, MsgType> dispatch);
