part of mvu_flutter;

/// Base [Update] class.
///
/// Every [Update] class that is passed inside a [Program] must
/// extend this class. Exists for safety and to reduce amount of code
/// that must be typed – specifying the generic will help to generate method
/// with all types in place.
@immutable
abstract class Update<ModelType extends Model, MsgType extends Msg> {
  ProducedState<ModelType, MsgType> update(MsgType message, ModelType model);
}
