part of mvu_flutter;

class _Rebuilder<T> {
  late T _value;
  void Function()? _marker;

  _Rebuilder(T inputValue) {
    _value = inputValue;
  }

  set value(T inputValue) {
    if (_value != inputValue) {
      _value = inputValue;
      if (_marker != null) {
        _marker!();
      }
    }
  }

  T get value => _value;

  void dispose() {
    _marker = null;
  }

  void setMarker(BuildContext context) {
    if (_marker == null) {
      _marker = (context as Element).markNeedsBuild;
    }
  }
}
